class julingClientMainObject {
    constructor(config) {
        this.julingSdkVersion = '1.0';
        this.config = config;
        this.loginUrl = `https://h5sdk.juling-game.com/Channel/login/julingGame/${config.julingGame}/julingChannel/${config.julingChannel}/julingSubChannel/${config.julingSubChannel}`;
        this.payUrl = 'https://h5sdk.juling-game.com/game/pay';
    }

    login(callback) {
        var H5SDK_this = this;
        qg.login({
            success: function(res) {
                if(res && res.data.session){
                    var params = Object.keys(res.data).map(function (key) {
                        return encodeURIComponent(key) + "=" + encodeURIComponent(res.data[key]);
                    }).join("&");
                    var xhr = new XMLHttpRequest();
                    xhr.open('POST', H5SDK_this.loginUrl, true);
                    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                    xhr.onreadystatechange = function() {
                        if (xhr.readyState == 4 && xhr.status == 200) {
                            var response = JSON.parse(xhr.response);
                            if (typeof(response.errorCode) != undefined && response.errorCode == 0) {
                                H5SDK_this = Object.assign(H5SDK_this, response.data)
                            }
                            callback(response)
                        }

                    };
                    xhr.send(params);
                }
            },
            fail: function(res) {
                callback({ errorCode: 1001, errorMessage: '服务器接口请求错误' });
            }
        });
    }

    pay(postData, callback) {
        postData = Object.assign(this, postData);
        var params = Object.keys(postData).map(function(key) {
            return encodeURIComponent(key) + "=" + encodeURIComponent(postData[key]);
        }).join("&");
        var xhr = new XMLHttpRequest();
        xhr.open('POST', this.payUrl);
        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4 && xhr.status == 200) {
                var response = JSON.parse(xhr.response);
                if (response.errorCode == 0) {
                    qg.pay({
                        orderInfo:{
                            appId: response.data.appId,
                            appAccountId: response.data.appAccountId,
                            session: response.data.session,
                            cpOrderId: response.data.cpOrderId,
                            cpUserInfo: response.data.cpUserInfo,
                            displayName: response.data.displayName,
                            feeValue:response.data.feeValue,
                            sign:response.data.sign,
                        },
                        
                        success: function(data){
                            if(data.resultStatus == 9000) {
                                callback({'errorCode' : '0','errorMessage' : '支付成功'});
                            } else {
                                callback({'errorCode' : data.resultStatus,'errorMessage' : data.memo});
                            }
                        },
                        fail: function(data){
                            callback({'errorCode' : data.resultStatus,'errorMessage' : '错误代码:' + data.memo});
                        }
                    });
                } else {
                    callback(response);
                }
            }
        };
        xhr.send(params);
    }
}

module.exports = julingClientMainObject;